INITSEG = 0x9000
SYSSEG = 0x1000
SETUPSEG = 0x9020
DELTA_INITSEG = SETUPSEG - INITSEG
.globl begtext, begdata, begbss, endtext, enddata, endbss
.text
begtext:
.data
begdata:
.bss
begbss:
.text
entry start
start:
jmp start_of_setup
.ascii "HdrS"
.word 0x0201
realmode_swtch: .word 0,0
start_sys_seg: .word SYSSEG
.word kernel_version
type_of_loader: .byte 0
loadflags: .byte 0
LOADED_HIGH = 1
CAN_USE_HEAP = 0x80
setup_move_size: .word 0x8000
code32_start: .long 0x1000
ramdisk_image: .long 0
ramdisk_size: .long 0
bootsect_kludge:
.word bootsect_helper,SETUPSEG
heap_end_ptr: .word modelist+1024
start_of_setup:
mov ax,#0x01500
mov dl,#0x81
int 0x13
mov ax,cs
mov ds,ax
cmp setup_sig1,#0xAA55
jne bad_sig
cmp setup_sig2,#0x5A5A
jne bad_sig
jmp good_sig1
prtstr: lodsb
AND al,al
jz fin
call prtchr
jmp prtstr
fin: ret
prtsp2: call prtspc
prtspc: mov al,#0x20
prtchr: push ax
push cx
XOR bh,bh
mov cx,#0x01
mov ah,#0x0e
int 0x10
pop cx
pop ax
ret
beep: mov al,#0x07
jmp prtchr
no_sig_mess: .ascii "No setup signature found ..."
db 0x00
good_sig1:
jmp good_sig
bad_sig:
mov ax,cs
sub ax,#DELTA_INITSEG
mov ds,ax
XOR bh,bh
mov bl,[497]
sub bx,#4
shl bx,#8
mov cx,bx
shr bx,#3
add bx,#SYSSEG
seg cs
mov start_sys_seg,bx
mov di,#2048
sub si,si
mov ax,cs
mov es,ax
mov ax,#SYSSEG
mov ds,ax
rep
movsw
mov ax,cs
mov ds,ax
cmp setup_sig1,#0xAA55
jne no_sig
cmp setup_sig2,#0x5A5A
jne no_sig
jmp good_sig
no_sig:
lea si,no_sig_mess
call prtstr
no_sig_loop:
jmp no_sig_loop
good_sig:
mov ax,cs
sub ax,#DELTA_INITSEG
mov ds,ax
seg cs
test byte ptr loadflags,#LOADED_HIGH
jz loader_ok
seg cs
cmp byte ptr type_of_loader,#0
jnz loader_ok
push cs
pop ds
lea si,loader_panic_mess
call prtstr
jmp no_sig_loop
loader_panic_mess:
.ascii "Wrong loader, giving up..."
db 0
loader_ok:
int 0x12
mov [0xc0],ax
mov ah,#0x88
int 0x15
mov [0x02],ax
mov ax,#0xE801
int 0x15
jnc E801_is_supported
XOR cx, cx
XOR dx, dx
E801_is_supported:
mov [0xc2],cx
mov [0xc4],dx
mov ax,ds
mov es,ax
XOR ebx,ebx
mov [0xa0+0x00],ebx
mov [0xa0+0x04],ebx
mov [0xa0+0x08],ebx
mov [0xa0+0x0c],ebx
mov [0xa0+0x10],ebx
mov [0xa0+0x14],ebx
mov [0xa0+0x18],ebx
mov [0xa0+0x1c],ebx
mov esi, ebx
get_memory_map:
mov eax,#0x0000e820
mov edx,#0x534d4150
mov ecx,#0x14
mov di,#0x80
int 0x15
jc terminate_map
cmpb [0x80+0x10],#0x01
jne is_not_dram
mov eax,[0x80+0x0]
mov 0xa0+0x0(esi), eax
mov eax,[0x80+0x8]
mov 0xa0+0x4(esi), eax
add esi,#8
cmp esi,#0x20
jge terminate_map
is_not_dram:
cmp ebx,#0x0
jne get_memory_map
terminate_map:
cmp esi,#0x20
jge no_more_map
XOR ebx, ebx
mov 0xa0+0x0(esi), ebx
mov 0xa0+0x4(esi), ebx
no_more_map:
mov ax,#0x0305
XOR bx,bx
int 0x16
call video
mov ax,cs
sub ax,#DELTA_INITSEG
push ax
mov di,#0x0080
push di
mov bl,#0x80
cld
next_drive:
cmpb bl,#0x84
jge no_more_drives
mov ax,#0x1500
mov dl,bl
int 0x13
jc no_more_drives
cmpb ah, #0x03
jne skip_drive
mov ax,#0x0800
mov dl,bl
int 0x13
jc no_more_drives
pop di
pop es
XOR ah,ah
mov al, dl
stosw
mov al, dh
inc ax
stosw
mov al, ch
mov ah, cl
shr ah, #6
inc ax
stosw
mov al, cl
AND al, #0x3f
XOR ah,ah
stosw
push es
push di
skip_drive:
inc bl
jmp next_drive
no_more_drives:
pop di
pop es
XOR ax,ax
stosw
mov ax,cs
sub ax,#DELTA_INITSEG
mov ds,ax
mov [0x1ff],#0
int 0x11
test al,#0x04
jz no_psmouse
mov [0x1ff],#0xaa
no_psmouse:
seg cs
cmp realmode_swtch,#0
jz rmodeswtch_normal
seg cs
callf far * realmode_swtch
jmp rmodeswtch_end
rmodeswtch_normal:
push cs
call default_switch
rmodeswtch_end:
seg cs
mov eax,code32_start
seg cs
mov code32,eax
seg cs
test byte ptr loadflags,#LOADED_HIGH
jz do_move0
jmp end_move
do_move0:
mov ax,#0x100
mov bp,cs
sub bp,#DELTA_INITSEG
seg cs
mov bx,start_sys_seg
cld
do_move:
mov es,ax
inc ah
mov ds,bx
add bx,#0x100
sub di,di
sub si,si
mov cx,#0x800
rep
movsw
cmp bx,bp
jb do_move
end_move:
mov ax,cs
mov ds,ax
mov ax,cs
cmp ax,#SETUPSEG
je end_move_self
cli
sub ax,#DELTA_INITSEG
mov dx,ss
cmp dx,ax
jb move_self_1
add dx,#INITSEG
sub dx,ax
move_self_1:
mov ds,ax
mov ax,#INITSEG
mov es,ax
seg cs
mov cx,setup_move_size
std
mov di,cx
dec di
mov si,di
sub cx,#move_self_here+0x200
rep
movsb
jmpi move_self_here,SETUPSEG
move_self_here:
mov cx,#move_self_here+0x200
rep
movsb
mov ax,#SETUPSEG
mov ds,ax
mov ss,dx
end_move_self:
lidt idt_48
lgdt gdt_48
call empty_8042
mov al,#0xD1
out #0x64,al
call empty_8042
mov al,#0xDF
out #0x60,al
call empty_8042
XOR ax,ax
out #0xf0,al
call delay
out #0xf1,al
call delay
mov al,#0x11
out #0x20,al
call delay
out #0xA0,al
call delay
mov al,#0x20
out #0x21,al
call delay
mov al,#0x28
out #0xA1,al
call delay
mov al,#0x04
out #0x21,al
call delay
mov al,#0x02
out #0xA1,al
call delay
mov al,#0x01
out #0x21,al
call delay
out #0xA1,al
call delay
mov al,#0xFF
out #0xA1,al
call delay
mov al,#0xFB
out #0x21,al
mov ax,#1
lmsw ax
jmp flush_instr
flush_instr:
XOR bx,bx
db 0x66,0xea
code32: dd 0x1000
dw 0x10
kernel_version: .ascii "2.0.27"
.ascii " ("
.ascii "root"
.ascii "@"
.ascii "srirangam.be.com"
.ascii ") "
.ascii "#1 Mon Oct 20 15:29:23 PDT 1997"
db 0
default_switch:
cli
mov al,#0x80
out #0x70,al
retf
bootsect_helper:
seg cs
cmp word ptr bootsect_es,#0
jnz bootsect_second
seg cs
mov byte ptr type_of_loader,#0x20
mov ax,es
shr ax,#4
seg cs
mov byte ptr bootsect_src_base+2,ah
mov ax,es
seg cs
mov bootsect_es,ax
sub ax,#SYSSEG
retf
bootsect_second:
push cx
push si
push bx
test bx,bx
jne bootsect_ex
mov cx,#0x8000
push cs
pop es
mov si,#bootsect_gdt
mov ax,#0x8700
int 0x15
jc bootsect_panic
seg cs
mov es,bootsect_es
seg cs
inc byte ptr bootsect_dst_base+2
bootsect_ex:
seg cs
mov ah, byte ptr bootsect_dst_base+2
shl ah,4
XOR al,al
pop bx
pop si
pop cx
retf
bootsect_gdt:
.word 0,0,0,0
.word 0,0,0,0
bootsect_src:
.word 0xffff
bootsect_src_base:
.byte 0,0,1
.byte 0x93
.word 0
bootsect_dst:
.word 0xffff
bootsect_dst_base:
.byte 0,0,0x40
.byte 0x93
.word 0
.word 0,0,0,0
.word 0,0,0,0
bootsect_es:
.word 0
bootsect_panic:
push cs
pop ds
cld
lea si,bootsect_panic_mess
call prtstr
bootsect_panic_loop:
jmp bootsect_panic_loop
bootsect_panic_mess:
.ascii "INT15 refuses to access high mem, giving up..."
db 0
empty_8042:
call delay
in al,#0x64
test al,#1
jz no_output
call delay
in al,#0x60
jmp empty_8042
no_output:
test al,#2
jnz empty_8042
ret
gettime:
push cx
mov ah,#0x02
int 0x1a
mov al,dh
AND al,#0x0f
mov ah,dh
mov cl,#0x04
shr ah,cl
aad
pop cx
ret
delay:
.word 0x00eb
ret
gdt:
.word 0,0,0,0
.word 0,0,0,0
.word 0xFFFF
.word 0x0000
.word 0x9A00
.word 0x00CF
.word 0xFFFF
.word 0x0000
.word 0x9200
.word 0x00CF
idt_48:
.word 0
.word 0,0
gdt_48:
.word 0x800
.word 512+gdt,0x9
video:
push ds
push ds
pop fs
push cs
pop ds
push cs
pop es
XOR ax,ax
mov gs,ax
cld
call basic_detect
seg fs
mov ax,[0x01fa]
cmp ax,#0xfffd
jz vid2
call mode_set
jc vid1
lea si,badmdt
call prtstr
vid2:
call mode_menu
vid1:
call restore_screen
call mode_params
pop ds
ret
basic_detect:
seg fs
movb [15],#0
mov ah,#0x12
mov bl,#0x10
int 0x10
seg fs
mov [10],bx
cmp bl,#0x10
je basret
incb [adapter]
mov ax,#0x1a00
int 0x10
cmp al,#0x1a
jne basret
seg fs
incb [15]
incb [adapter]
basret: ret
mode_params:
mov ah,#0x03
XOR bh,bh
int 0x10
seg fs
mov [0],dx
mov ah,#0x0f
int 0x10
seg fs
mov [4],bx
seg fs
mov [6],ax
cmp al,#7
jnz mopar0
mov [video_segment],#0xb000
mopar0:
seg gs
mov ax,[0x485]
seg fs
mov [16],ax
mov ax,[force_size]
OR ax,ax
jz mopar1
seg fs
mov [7],ah
seg fs
mov [14],al
ret
mopar1: mov al,#25
cmpb [adapter],#0
jz mopar2
seg gs
mov al,[0x484]
inc al
mopar2:
seg fs
movb [14],al
ret
mode_menu:
lea si,keymsg
call prtstr
call flush
nokey:
call getkt
cmp al,#0x0d
je listm
cmp al,#0x20
je defmd1
call beep
jmp nokey
defmd1:
ret
listm:
call mode_table
listm0:
lea si,name_bann
call prtstr
mov si,[card_name]
OR si,si
jnz an2
mov al,[adapter]
lea si,old_name
OR al,al
jz an1
lea si,ega_name
dec al
jz an1
lea si,vga_name
jmp an1
an2:
call prtstr
lea si,svga_name
an1:
call prtstr
lea si,listhdr
call prtstr
mov dl,#0x30
lea si,modelist
lm1:
cmp (si),#0xfffd
jz lm2
mov al,dl
call prtchr
call prtsp2
lodsw
call prthw
call prtsp2
mov al,(si+1)
call prtdec
mov al,#0x78
call prtchr
lodsw
call prtdec
mov al,#0x0d
call prtchr
mov al,#0x0a
call prtchr
inc dl
cmp dl,#0x3a
jnz lm1
mov dl,#0x61
jmp lm1
lm2:
lea si,prompt
call prtstr
lea di,edit_buf
lm3:
call getkey
cmp al,#0x0d
jz lment
cmp al,#0x08
jz lmbs
cmp al,#0x20
jc lm3
cmp di,#edit_buf+4
jz lm3
stosb
call prtchr
jmp lm3
lmbs:
cmp di,#edit_buf
jz lm3
dec di
mov al,#0x08
call prtchr
call prtspc
mov al,#0x08
call prtchr
jmp lm3
lment:
movb (di),#0
lea si,crlft
call prtstr
lea si,edit_buf
cmpb (si),#0
jz lmdef
cmpb (si+1),#0
jz mnusel
cmp (si),#0x6373
jnz lmhx
cmp (si+2),#0x6e61
jz lmscan
lmhx:
XOR bx,bx
lmhex:
lodsb
OR al,al
jz lmuse1
sub al,#0x30
jc lmbad
cmp al,#10
jc lmhx1
sub al,#7
AND al,#0xdf
cmp al,#10
jc lmbad
cmp al,#16
jnc lmbad
lmhx1:
shl bx,#4
OR bl,al
jmp lmhex
lmuse1:
mov ax,bx
jmp lmuse
mnusel:
lodsb
XOR ah,ah
sub al,#0x30
jc lmbad
cmp al,#10
jc lmuse
cmp al,#0x61-0x30
jc lmbad
sub al,#0x61-0x30-10
cmp al,#36
jnc lmbad
lmuse:
call mode_set
jc lmdef
lmbad:
lea si,unknt
call prtstr
br lm2
lmscan:
cmpb [adapter],#0
jz lmbad
mov [mt_end],#0
movb [scanning],#1
call mode_table
br listm0
lmdef:
ret
setv7:
call store_screen
sub bh,#0x0900>>8
mov ax,#0x6f05
int 0x10
stc
ret
setalias:
mov ax,#0x0f00
inc bx
jz mode_set
mov al,#0x0f01-0x0f00
inc bx
jnz setbad
mode_set:
mov bx,ax
cmp ah,#0xff
jz setalias
test ah,#0x8000>>8
jnz setrec
cmp ah,#0x1000>>8
jnc setres
cmp ah,#0x0f00>>8
jz setspc
cmp ah,#0x0900>>8
jz setv7
cmp ah,#0x0200>>8
jnc setvesa
OR ah,ah
jz setmenu
dec ah
jz setbios
setbad:
clc
movb [do_restore],#0
ret
setvesa:
call store_screen
sub bh,#0x0200>>8
mov ax,#0x4f02
int 0x10
cmp ax,#0x004f
jnz setbad
stc
ret
setbios:
call store_screen
int 0x10
push bx
mov ah,#0x0f
int 0x10
pop bx
cmp al,bl
jnz setbad
stc
ret
setspc:
XOR bh,bh
cmp bl,#0x0f08-0x0f00
jnc setbad
add bx,bx
.word 0xa7ff, spec_inits
setmenu:
push bx
call mode_table
pop ax
shl ax,#2
add si,ax
cmp si,di
jnc setbad
mov ax,(si)
_m_s:
jmp mode_set
setres:
push bx
call mode_table
pop bx
xchg bh,bl
setr1:
lodsw
cmp ax,#0xfffd
jz setbad
lodsw
cmp ax,bx
jnz setr1
mov ax,(si-4)
jmp _m_s
setrec:
sub ah,#0x8000>>8
call mode_set
jnc rct3
seg gs
mov ax,[0x485]
seg gs
mov bl,[0x484]
inc bl
mul bl
dec ax
mov dx,#0x3d4
mov bx,ax
mov al,#0x12
mov ah,bl
out dx,ax
mov al,#0x07
call inidx
xchg ah,al
AND ah,#0xbd
shr bh,#1
jnc rct1
OR ah,#0x02
rct1:
shr bh,#1
jnc rct2
OR ah,#0x40
rct2:
mov al,#0x07
out dx,ax
stc
rct3:
ret
spec_inits:
.word set_80x25
.word set_8pixel
.word set_80x43
.word set_80x28
.word set_current
.word set_80x30
.word set_80x34
.word set_80x60
set_80x25:
mov [force_size],#0x5019
use_80x25:
mov ah,#0x0f
int 0x10
cmp ax,#0x5007
jz st80
cmp ax,#0x5003
jnz force3
st80:
cmpb [adapter],#0
jz set80
seg gs
mov al,[0x0484]
OR al,al
jz set80
cmp al,#24
jz set80
force3:
call store_screen
mov ax,#0x0003
int 0x10
set80:
stc
ret
set_8pixel:
call store_screen
call use_80x25
set_8pt:
mov ax,#0x1112
XOR bl,bl
int 0x10
mov ax,#0x1200
mov bl,#0x20
int 0x10
mov ax,#0x1201
mov bl,#0x34
int 0x10
mov ah,#0x01
mov cx,#0x0607
int 0x10
set_current:
stc
ret
set_80x28:
call store_screen
call use_80x25
set14:
mov ax,#0x1111
XOR bl,bl
int 0x10
mov ah,#0x01
mov cx,#0x0b0c
int 0x10
stc
ret
set_80x43:
call store_screen
mov ax,#0x1201
mov bl,#0x30
int 0x10
mov ax,#0x0003
int 0x10
jmp set_8pt
set_80x30:
call use_80x25
call store_screen
mov dx,#0x3cc
in al,dx
mov dl,#0xd4
ror al,#1
jc set48a
mov dl,#0xb4
set48a:
mov ax,#0x0c11
call outidx
mov ax,#0x0b06
call outidx
mov ax,#0x3e07
call outidx
mov ax,#0xea10
call outidx
mov ax,#0xdf12
call outidx
mov ax,#0xe715
call outidx
mov ax,#0x0416
call outidx
push dx
mov dl,#0xcc
in al,dx
mov dl,#0xc2
AND al,#0x0d
OR al,#0xe2
out dx,al
pop dx
mov [force_size],#0x501e
stc
ret
set_80x34:
call set_80x30
call set14
mov ax,#0xdb12
mov [force_size],#0x5022
setvde:
call outidx
stc
ret
set_80x60:
call set_80x30
call set_8pt
mov ax,#0xdf12
mov [force_size],#0x503c
jmp setvde
store_screen:
cmpb [do_restore],#0
jnz stsr
testb [loadflags],#CAN_USE_HEAP
jz stsr
push ax
push bx
push [force_size]
mov [force_size],#0
call mode_params
pop [force_size]
seg fs
mov ah,[14]
seg fs
mov al,[7]
mov bx,ax
mul ah
mov cx,ax
add ax,ax
add ax,#modelist+1024+4
cmp ax,[heap_end_ptr]
jnc sts1
seg fs
mov ax,[0]
lea di,modelist+1024
stosw
mov ax,bx
stosw
push ds
mov ds,[video_segment]
XOR si,si
rep
movsw
pop ds
incb [do_restore]
sts1:
pop bx
pop ax
stsr:
ret
restore_screen:
cmpb [do_restore],#0
jz res1
call mode_params
seg fs
mov cl,[14]
seg fs
mov ch,[7]
lea si,modelist+1024
lodsw
mov dx,ax
cmp dh,cl
jc res2
mov dh,cl
dec dh
res2:
cmp dl,ch
jc res3
mov dl,ch
dec dl
res3:
mov ah,#0x02
mov bh,#0x00
int 0x10
lodsw
mov dl,ah
mov ah,#0
mov bx,ax
cmp dl,cl
jc res4
push ax
mov al,dl
sub al,cl
mul bl
add si,ax
add si,ax
pop ax
mov dl,cl
res4:
cmp al,ch
jc res5
mov al,ch
res5:
mov cl,#0
xchg cl,ch
mov bp,cx
push es
mov es,[video_segment]
XOR di,di
add bx,bx
add bp,bp
res6:
push si
push di
mov cx,ax
rep
movsw
pop di
pop si
add di,bp
add si,bx
dec dl
jnz res6
pop es
res1:
ret
outidx:
out dx,al
push ax
mov al,ah
inc dx
out dx,al
dec dx
pop ax
ret
mode_table:
mov di,[mt_end]
OR di,di
jnz mtab1x
lea di,modelist
mov eax,#0x0f00 + 0x50190000
stosd
mov al,[adapter]
OR al,al
jz mtabe
dec al
jnz mtabv
mov eax,#0x0f01 + 0x502b0000
stosd
jmp mtabe
mtab1x:
jmp mtab1
mtabv:
lea si,vga_modes
mov cx,#12
rep
movsw
cmpb [scanning],#0
jz mscan1
call mode_scan
mscan1:
call vesa_modes
cmpb [scanning],#0
jnz mscan2
call svga_modes
mscan2:
mtabe:
lea si,modelist
mov dx,di
mov di,si
cmt1:
cmp si,dx
jz cmt2
lea bx,modelist
mov cx,(si+2)
cmt3:
cmp si,bx
jz cmt4
cmp cx,(bx+2)
jz cmt5
add bx,#4
jmp cmt3
cmt4:
movsd
jmp cmt1
cmt5:
add si,#4
jmp cmt1
cmt2:
mov (di),#0xfffd
mov [mt_end],di
mtab1:
lea si,modelist
ret0:
ret
vga_modes:
.word 0x0f01
.word 0x5032
.word 0x0f02
.word 0x502b
.word 0x0f03
.word 0x501c
.word 0x0f05
.word 0x501e
.word 0x0f06
.word 0x5022
.word 0x0f07
.word 0x503c
vesa_modes:
cmpb [adapter],#2
jnz ret0
mov bp,di
add di,#0x200
mov ax,#0x4f00
int #0x10
mov di,bp
cmp ax,#0x004f
jnz ret0
cmp (di+0x200),#0x4556
jnz ret0
cmp (di+0x202),#0x4153
jnz ret0
mov [card_name],#vesa_name
push gs
lgs si,(di+0x20e)
mov cx,#128
vesa1:
seg gs
lodsw
cmp ax,#0xffff
jz vesar
cmp ax,#0x0080
jc vesa2
OR ah,ah
jz vesan
cmp ax,#0x0800
jnc vesae
vesa2:
push cx
mov cx,ax
mov ax,#0x4f01
int 0x10
mov bx,cx
add bh,#0x0200>>8
pop cx
cmp ax,#0x004f
jnz vesan
mov al,(di)
AND al,#0x19
cmp al,#0x09
jnz vesan
cmp (di+8),#0xb800
jnz vesan
testb (di),#2
mov (di),bx
jz vesa3
XOR dx,dx
mov bx,(di+0x12)
OR bh,bh
jnz vesan
mov (di+3),bl
mov ax,(di+0x14)
OR ah,ah
jnz vesan
mov (di+2),al
mul bl
cmp ax,#8193
jnc vesan
jmp vesaok
vesa3:
sub bx,#0x8108
jc vesan
cmp bx,#5
jnc vesan
mov ax,(bx+vesa_text_mode_table)
mov (di+2),ax
vesaok:
add di,#4
vesan:
loop vesa1
vesae:
lea si,vesaer
call prtstr
mov di,bp
vesar:
pop gs
ret
vesa_text_mode_table:
db 60, 80
db 25, 132
db 43, 132
db 50, 132
db 60, 132
mode_scan:
mov cx,#0x0100
scm1:
mov ah,#0
mov al,cl
int 0x10
mov ah,#0x0f
int 0x10
cmp al,cl
jnz scm2
mov dx,#0x3c0
mov al,#0x10
call inidx
AND al,#0x03
jnz scm2
mov dl,#0xce
mov al,#0x06
call inidx
shr al,#1
jc scm2
mov dl,#0xd4
mov al,#0x0f
call inidx
OR al,al
jnz scm2
mov ax,cx
stosw
seg gs
mov al,[0x484]
inc al
stosb
seg gs
mov ax,[0x44a]
stosb
scm2:
inc cl
jns scm1
mov ax,#0x0003
int 0x10
ret
tstidx:
out dx,ax
inidx:
out dx,al
inc dx
in al,dx
dec dx
ret
svga_modes:
lea si,svga_table
dosvga:
lodsw
mov bp,ax
OR ax,ax
jz didsv1
lodsw
push si
push di
push es
mov bx,#0xc000
mov es,bx
call ax
pop es
pop di
pop si
OR bp,bp
jz dosvga
mov si,bp
mov ah,[svga_prefix]
cpsvga:
lodsb
OR al,al
jz didsv
stosw
movsw
jmp cpsvga
didsv:
mov [card_name],si
didsv1:
ret
svga_table:
.word ati_md, ati_test
.word oak_md, oak_test
.word paradise_md, paradise_test
.word realtek_md, realtek_test
.word s3_md, s3_test
.word chips_md, chips_test
.word video7_md, video7_test
.word cirrus5_md, cirrus5_test
.word cirrus6_md, cirrus6_test
.word cirrus1_md, cirrus1_test
.word ahead_md, ahead_test
.word everex_md, everex_test
.word genoa_md, genoa_test
.word trident_md, trident_test
.word tseng_md, tseng_test
.word 0
s3_test:
mov cx,#0x0f35
mov dx,#0x03d4
movb al,#0x38
call inidx
mov bh,al
mov ax,#0x0038
call outidx
movb al,cl
call inidx
movb bl,al
andb al,#0xf0
movb ah,al
movb al,cl
call outidx
call inidx
andb al,ch
jz s3_2
movb ah,bl
mov al,cl
call outidx
jmp s3_1
s3_2:
mov ax,cx
orb ah,bl
call outidx
call inidx
andb al,cl
push ax
movb ah,bl
movb al,cl
call outidx
pop ax
cmp al,ch
je no_s3
s3_1:
mov ax,#0x4838
call outidx
movb al,cl
call inidx
movb bl,al
andb al,#0xf0
movb ah,al
movb al,cl
call outidx
call inidx
andb al,ch
jnz no_s3
mov ax,cx
orb ah,bl
call outidx
call inidx
andb al,ch
push ax
movb ah,bl
movb al,cl
call outidx
pop ax
cmp al,ch
jne no_s31
movb al,#0x30
call inidx
lea di,idS3
mov cx,#0x10
repne
scasb
je no_s31
movb ah,bh
movb al,#0x38
jmp s3rest
no_s3:
movb al,#0x35
movb ah,bl
call outidx
no_s31:
XOR bp,bp
s3rest:
movb ah,bh
movb al,#0x38
br outidx
idS3:
.byte 0x81, 0x82, 0x90, 0x91, 0x92, 0x93, 0x94, 0x95
.byte 0xa0, 0xa1, 0xa2, 0xa3, 0xa4, 0xa5, 0xa8, 0xb0
s3_md:
.byte 0x54, 0x2b, 0x84
.byte 0x55, 0x19, 0x84
.byte 0
.ascii "S3"
.byte 0
ati_test:
lea si,idati
mov di,#0x31
mov cx,#0x09
repe
cmpsb
je atiok
XOR bp,bp
atiok:
ret
idati:
.ascii "761295520"
ati_md:
.byte 0x23, 0x19, 0x84
.byte 0x33, 0x2c, 0x84
.byte 0x22, 0x1e, 0x64
.byte 0x21, 0x19, 0x64
.byte 0x58, 0x21, 0x50
.byte 0x5b, 0x1e, 0x50
.byte 0
.ascii "ATI"
.byte 0
ahead_test:
mov ax,#0x200f
mov dx,#0x3ce
out dx,ax
inc dx
in al,dx
cmp al,#0x20
je isahed
cmp al,#0x21
je isahed
XOR bp,bp
isahed:
ret
ahead_md:
.byte 0x22, 0x2c, 0x84
.byte 0x23, 0x19, 0x84
.byte 0x24, 0x1c, 0x84
.byte 0x2f, 0x32, 0xa0
.byte 0x32, 0x22, 0x50
.byte 0x34, 0x42, 0x50
.byte 0
.ascii "Ahead"
.byte 0
chips_test:
mov dx,#0x3c3
in al,dx
OR al,#0x10
out dx,al
mov dx,#0x104
in al,dx
mov bl,al
mov dx,#0x3c3
in al,dx
AND al,#0xef
out dx,al
cmp bl,#0xa5
je cantok
XOR bp,bp
cantok:
ret
chips_md:
.byte 0x60, 0x19, 0x84
.byte 0x61, 0x32, 0x84
.byte 0
.ascii "Chips & Technologies"
.byte 0
cirrus1_test:
mov dx,#0x3d4
mov al,#0x0c
out dx,al
inc dx
in al,dx
mov bl,al
XOR al,al
out dx,al
dec dx
mov al,#0x1f
out dx,al
inc dx
in al,dx
mov bh,al
XOR ah,ah
shl al,#4
mov cx,ax
mov al,bh
shr al,#4
add cx,ax
shl cx,#8
add cx,#6
mov ax,cx
mov dx,#0x3c4
out dx,ax
inc dx
in al,dx
AND al,al
jnz nocirr
mov al,bh
out dx,al
in al,dx
cmp al,#0x01
je iscirr
nocirr:
XOR bp,bp
iscirr:
mov dx,#0x3d4
mov al,bl
XOR ah,ah
shl ax,#8
add ax,#0x0c
out dx,ax
ret
cirrus1_md:
.byte 0x1f, 0x19, 0x84
.byte 0x20, 0x2c, 0x84
.byte 0x22, 0x1e, 0x84
.byte 0x31, 0x25, 0x64
.byte 0
.ascii "Cirrus Logic 5X0"
.byte 0
cirrus5_test:
mov dx,#0x3c4
mov al,#6
call inidx
mov bl,al
mov ax,#6
call tstidx
cmp al,#0x0f
jne c5fail
mov ax,#0x1206
call tstidx
cmp al,#0x12
jne c5fail
mov al,#0x1e
call inidx
mov bh,al
mov ah,bh
AND ah,#0xc0
mov al,#0x1e
call tstidx
AND al,#0x3f
jne c5xx
mov al,#0x1e
mov ah,bh
OR ah,#0x3f
call tstidx
XOR al,#0x3f
AND al,#0x3f
c5xx:
pushf
mov al,#0x1e
mov ah,bh
out dx,ax
popf
je c5done
c5fail:
XOR bp,bp
c5done:
mov al,#6
mov ah,bl
out dx,ax
ret
cirrus5_md:
.byte 0x14, 0x19, 0x84
.byte 0x54, 0x2b, 0x84
.byte 0
.ascii "Cirrus Logic 54XX"
.byte 0
cirrus6_test:
mov dx,#0x3ce
mov al,#0x0a
call inidx
mov bl,al
mov ax,#0xce0a
call tstidx
OR al,al
jne c2fail
mov ax,#0xec0a
call tstidx
cmp al,#0x01
jne c2fail
mov al,#0xaa
call inidx
shr al,#4
sub al,#4
jz c6done
dec al
jz c6done
sub al,#2
jz c6done
dec al
jz c6done
c2fail:
XOR bp,bp
c6done:
mov al,#0x0a
mov ah,bl
out dx,ax
ret
cirrus6_md:
.byte 0
.ascii "Cirrus Logic 64XX"
.byte 0
everex_test:
mov ax,#0x7000
XOR bx,bx
int 0x10
cmp al,#0x70
jne noevrx
shr dx,#4
cmp dx,#0x678
je evtrid
cmp dx,#0x236
jne evrxok
evtrid:
lea bp,trident_md
evrxok:
ret
noevrx:
XOR bp,bp
ret
everex_md:
.byte 0x03, 0x22, 0x50
.byte 0x04, 0x3c, 0x50
.byte 0x07, 0x2b, 0x64
.byte 0x08, 0x4b, 0x64
.byte 0x0a, 0x19, 0x84
.byte 0x0b, 0x2c, 0x84
.byte 0x16, 0x1e, 0x50
.byte 0x18, 0x1b, 0x64
.byte 0x21, 0x40, 0xa0
.byte 0x40, 0x1e, 0x84
.byte 0
.ascii "Everex/Trident"
.byte 0
genoa_test:
lea si,idgenoa
XOR ax,ax
seg es
mov al,[0x37]
mov di,ax
mov cx,#0x04
dec si
dec di
l1: inc si
inc di
mov al,(si)
test al,al
jz l2
seg es
cmp al,(di)
l2: loope l1
OR cx,cx
je isgen
XOR bp,bp
isgen: ret
idgenoa: .byte 0x77, 0x00, 0x99, 0x66
genoa_md:
.byte 0x58, 0x20, 0x50
.byte 0x5a, 0x2a, 0x64
.byte 0x60, 0x19, 0x84
.byte 0x61, 0x1d, 0x84
.byte 0x62, 0x20, 0x84
.byte 0x63, 0x2c, 0x84
.byte 0x64, 0x3c, 0x84
.byte 0x6b, 0x4f, 0x64
.byte 0x72, 0x3c, 0x50
.byte 0x74, 0x42, 0x50
.byte 0x78, 0x4b, 0x64
.byte 0
.ascii "Genoa"
.byte 0
oak_test:
lea si,idoakvga
mov di,#0x08
mov cx,#0x08
repe
cmpsb
je isoak
XOR bp,bp
isoak:
ret
idoakvga:
.ascii "OAK VGA "
oak_md:
.byte 0x4e, 0x3c, 0x50
.byte 0x4f, 0x3c, 0x84
.byte 0x50, 0x19, 0x84
.byte 0x51, 0x2b, 0x84
.byte 0
.ascii "OAK"
.byte 0
paradise_test:
lea si,idparadise
mov di,#0x7d
mov cx,#0x04
repe
cmpsb
je ispara
XOR bp,bp
ispara:
ret
idparadise:
.ascii "VGA="
paradise_md:
.byte 0x41, 0x22, 0x50
.byte 0x47, 0x1c, 0x84
.byte 0x55, 0x19, 0x84
.byte 0x54, 0x2c, 0x84
.byte 0
.ascii "Paradise"
.byte 0
trident_test:
mov dx,#0x3c4
mov al,#0x0e
out dx,al
inc dx
in al,dx
xchg ah,al
XOR al,al
out dx,al
in al,dx
xchg al,ah
mov bl,al
AND bl,#0x02
jz setb2
AND al,#0xfd
jmp clrb2
setb2:
OR al,#0x02
clrb2:
out dx,al
AND ah,#0x0f
cmp ah,#0x02
je istrid
XOR bp,bp
istrid:
ret
trident_md:
.byte 0x50, 0x1e, 0x50
.byte 0x51, 0x2b, 0x50
.byte 0x52, 0x3c, 0x50
.byte 0x57, 0x19, 0x84
.byte 0x58, 0x1e, 0x84
.byte 0x59, 0x2b, 0x84
.byte 0x5a, 0x3c, 0x84
.byte 0
.ascii "Trident"
.byte 0
tseng_test:
mov dx,#0x3cd
in al,dx
mov bl,al
mov al,#0x55
out dx,al
in al,dx
mov ah,al
mov al,bl
out dx,al
cmp ah,#0x55
je istsen
isnot:
XOR bp,bp
istsen:
ret
tseng_md:
.byte 0x26, 0x3c, 0x50
.byte 0x2a, 0x28, 0x64
.byte 0x23, 0x19, 0x84
.byte 0x24, 0x1c, 0x84
.byte 0x22, 0x2c, 0x84
.byte 0x21, 0x3c, 0x84
.byte 0
.ascii "Tseng"
.byte 0
video7_test:
mov dx,#0x3cc
in al,dx
mov dx,#0x3b4
AND al,#0x01
jz even7
mov dx,#0x3d4
even7:
mov al,#0x0c
out dx,al
inc dx
in al,dx
mov bl,al
mov al,#0x55
out dx,al
in al,dx
dec dx
mov al,#0x1f
out dx,al
inc dx
in al,dx
mov bh,al
dec dx
mov al,#0x0c
out dx,al
inc dx
mov al,bl
out dx,al
mov al,#0x55
XOR al,#0xea
cmp al,bh
jne isnot
movb [svga_prefix],#0x0900>>8
ret
video7_md:
.byte 0x40, 0x2b, 0x50
.byte 0x43, 0x3c, 0x50
.byte 0x44, 0x3c, 0x64
.byte 0x41, 0x19, 0x84
.byte 0x42, 0x2c, 0x84
.byte 0x45, 0x1c, 0x84
.byte 0
.ascii "Video 7"
.byte 0
realtek_test:
lea si,idrtvga
mov di,#0x45
mov cx,#0x0b
repe
cmpsb
je isrt
XOR bp,bp
isrt:
ret
idrtvga:
.ascii "REALTEK VGA"
realtek_md:
.byte 0x1a, 0x3c, 0x50
.byte 0x1b, 0x19, 0x84
.byte 0x1c, 0x1e, 0x84
.byte 0x1d, 0x2b, 0x84
.byte 0x1e, 0x3c, 0x84
.byte 0
.ascii "REALTEK"
.byte 0
getkey:
XOR ah,ah
int 0x16
ret
getkt:
call gettime
add al,#30
cmp al,#60
jl lminute
sub al,#60
lminute:
mov cl,al
again:
mov ah,#0x01
int 0x16
jnz getkey
call gettime
cmp al,cl
jne again
mov al,#0x20
ret
flush:
mov ah,#0x01
int 0x16
jz empty
XOR ah,ah
int 0x16
jmp flush
empty:
ret
prthw:
push ax
mov al,ah
call prthb
pop ax
prthb:
push ax
shr al,#4
call prthn
pop ax
AND al,#0x0f
prthn:
cmp al,#0x0a
jc prth1
add al,#0x07
prth1:
add al,#0x30
br prtchr
prtdec:
push ax
push cx
XOR ah,ah
mov cl,#0x0a
idiv cl
cmp al,#0x09
jbe lt100
call prtdec
jmp skip10
lt100:
add al,#0x30
call prtchr
skip10:
mov al,ah
add al,#0x30
call prtchr
pop cx
pop ax
ret
adapter: .byte 0
mt_end: .word 0
edit_buf: .space 6
card_name: .word 0
scanning: .byte 0
do_restore: .byte 0
svga_prefix: .byte 0x0100>>8
video_segment: .word 0xb800
force_size: .word 0
keymsg:
.ascii "Press <RETURN> to see video modes available, "
.ascii "<SPACE> to continue or wait 30 secs"
db 0x0d, 0x0a, 0
listhdr:
db 0x0d, 0x0a
.ascii "Mode:    COLSxROWS:"
crlft:
db 0x0d, 0x0a, 0
prompt:
db 0x0d, 0x0a
.ascii "Enter mode number: "
db 0
unknt:
.ascii "Unknown mode ID. Try again."
db 0
badmdt:
.ascii "You passed an undefined mode number to setup."
db 0x0d, 0x0a, 0
vesaer:
.ascii "Error: Scanning of VESA modes failed. Please "
.ascii "report to <mj@k332.feld.cvut.cz>."
db 0x0d, 0x0a, 0
old_name:
.ascii "CGA/MDA/HGA"
db 0
ega_name:
.ascii "EGA"
db 0
svga_name:
.ascii " "
vga_name:
.ascii "VGA"
db 0
vesa_name:
.ascii "VESA"
db 0
name_bann:
.ascii "Video adapter: "
db 0
setup_sig1: .word 0xAA55
setup_sig2: .word 0x5A5A
modelist:
.text
endtext:
.data
enddata:
.bss
endbss:
